#!/usr/bin/python

import Headweb, HeadwebObjects
import mc
from xml.dom import minidom
import urllib, urllib2, os
import xbmc, xbmcgui, xbmcplugin
from GUIID import *

# Create the global HW API object that will be used.
api = HeadwebObjects.APIv3('http://api.headweb.com', '86cc9ddac31d11dea3d733b0e449c0be')

globalSearchQuery = None
globalBrowseQuery = None

PLAYER_JAVASCRIPT_URL = 'http://xarragon.terminal.se/headweb/headweb.js'

# These settings determine the image quality for listings and details.
# Input a real number between 0 and 1, 0 = worst, 1 = best.
# Listings are used when searching and browsing, details when viewing an item.
COVER_QUALITY_LISTING = 0.6
COVER_QUALITY_DETAILS = 1.0

def urlcode (url):
	url = url.replace(':', '%3A')
	url = url.replace('/', '%2F')
	url = url.replace('&', '%26')
	return url

def getBestLanguage ():
	"""Returns the most appropiate language based on the UI language."""
	language = xbmc.getLanguage().lower()
	mc.LogDebug("Headweb: XBMC system language is: " + language)
	
	# Default is generic English for anything but Swedish.
	if language == 'swedish':
		return Headweb.APIv3.LANG_SV
	else:
		return Headweb.APIv3.LANG_EN



def onSearchClick ():
	"""Called when the search button is clicked in the UI."""
	global api, globalSearchQuery
	
	#mc.LogDebug("Headweb: onSearchClick() called.")
	
	config = mc.GetApp().GetLocalConfig()
	#hw_lang = config.GetValue('headweb.com.language')
	
	searchString = mc.GetActiveWindow().GetEdit(ID_SEARCH_EDIT).GetText()
	searchString = searchString.strip()
	if not searchString:
		mc.ShowDialogNotification('Empty search query ignored.')
		return
	mc.ShowDialogWait()

	index = mc.GetActiveWindow().GetList(ID_MAIN_MENU).GetFocusedItem()
	mc.LogDebug('Headweb: Performing search query.')
	language = getBestLanguage()
	globalSearchQuery = api.search(searchString, 14, lang=language)

	listItems = mc.ListItems()
	for item in globalSearchQuery:
		listItems.append(playlistItemFromItem(item))
	
	listControl = mc.GetActiveWindow().GetList(ID_SEARCH_PANEL)
	listControl.SetItems(listItems)
	
	mc.GetActiveWindow().GetControl(ID_SEARCH_NEXT).SetEnabled(globalSearchQuery.hasNext())
	mc.GetActiveWindow().GetControl(ID_SEARCH_PREV).SetEnabled(globalSearchQuery.hasPrev())
	mc.GetActiveWindow().GetLabel(ID_SEARCH_STATUS).SetLabel(makeStatusString(globalSearchQuery))
	
	mc.HideDialogWait()

def onClearClick ():
	"""Clears the search result list and empties the search field."""
	
	#mc.LogDebug("Headweb: onClearClick() called.")
	
	mc.GetActiveWindow().GetEdit(ID_SEARCH_EDIT).SetText('')
	mc.GetActiveWindow().GetList(ID_SEARCH_PANEL).SetItems(mc.ListItems())
	mc.GetActiveWindow().GetButton(ID_SEARCH_PREV).SetEnabled(False)
	mc.GetActiveWindow().GetButton(ID_SEARCH_NEXT).SetEnabled(False)
	
def onSearchResultClick ():
	global api, globalSearchQuery
	#dialog = xbmcgui.WindowXMLDialog('MovieAction.xml', os.getcwd())

	#dialog.doModal()
	#del dialog

	# Retrieve the highlighted/selected item.
	try:
		index = mc.GetActiveWindow().GetList(ID_SEARCH_PANEL).GetFocusedItem()
		selectedItem = mc.GetActiveWindow().GetList(ID_SEARCH_PANEL).GetItems()[index]
	except:
		mc.ShowDialogNotification('Error: Unable to retrieve selected result.')
		return
	
	try:
		window = mc.GetWindow(14002)
		
		# Extract the ID of the selected item and find it in the query object.
		id = int(selectedItem.getProperty('id'))
		item = globalSearchQuery.getItemById(id)
		if Item == None:
			error = 'Headweb: No item could be found in the current search query matching the ID of ' + str(id) + '.'
			mc.LogDebug(str)
			raise Exception(str)
		
		# Get a high-quality cover image and use for the playback menu.
		# If the title has no cover then use the special "no-cover" image.
		cover = item.getCover(COVER_QUALITY_DETAILS)
		if cover == None:
			cover = ''
		window.GetImage(ID_PLAYBACK_COVER).SetTexture(cover)
		
		window.GetLabel(ID_PLAYBACK_TITLE).SetLabel('Movie name/title')
		window.GetLabel(ID_PLAYBACK_PRICE).SetLabel('39 SEK')
		
		mc.ActivateWindow(14002)
		
	except:
		mc.ShowDialogNotification('Error: Unable to show purchase dialog.')
		return

def onBrowseResultClick ():
	global api, globalBrowseQuery
	#dialog = xbmcgui.WindowXMLDialog('MovieAction.xml', os.getcwd())

	#dialog.doModal()
	#del dialog

	# Retrieve the highlighted/selected item.
	try:
		index = mc.GetActiveWindow().GetList(225).GetFocusedItem()
		selectedItem = mc.GetActiveWindow().GetList(225).GetItems()[index]
	except:
		mc.ShowDialogNotification('Error: Unable to retrieve selected result.')
		return
	
	try:
		mc.ActivateWindow(14002)
		window = mc.GetActiveWindow()
		
		window.GetImage(ID_PLAYBACK_COVER).SetTexture('')
		window.GetLabel(ID_PLAYBACK_TITLE).SetLabel('Movie name/title')
		window.GetLabel(ID_PLAYBACK_PRICE).SetLabel('39 SEK')
		
		
	except:
		mc.ShowDialogNotification('Error: Unable to show purchase dialog.')
		return
	
def onAccountInit ():
	accountInfoRefresh()

def onAccountRefreshClick ():
	"""Called when the user presses the "refresh" button on the account tab.
	This causes a reloading/refresh of the items in the "active rentals" and
	the general data displayed for the user."""
	mc.ShowDialogNotification('onAccountRefreshClick()')
	mc.ShowDialogWait()
	accountInfoRefresh()
	mc.HideDialogWait()
	mc.ShowDialogNotification('Account information refreshed.')
	
def accountInfoRefresh ():
	"""This function performs the task of refreshing the information on the
	"account" tab. This is called by other functions to perform the actual
	work."""
	global api
	
	activeRentalsList = mc.GetActiveWindow().GetList(ID_ACCOUNT_RENTAL_LIST)
	
	username = mc.GetApp().GetLocalConfig().GetValue('com.headweb.username')
	password = mc.GetApp().GetLocalConfig().GetValue('com.headweb.password')
	
	#mc.LogDebug("Headweb: Current username: \"%s\"" % username)
	#mc.LogDebug("Headweb: Current password: \"%s\"" % password)
	
	# Show error message and abort if no username/password is input.
	if username == None or password == None:
		#title = mc.GetLocalizedString(6000)
		#message = mc.GetLocalizedString(6010)
		#mc.ShowDialogOk(title, message)
		mc.ShowDialogOk("Login error", "You need to provide credentials.")
		return
	
	# Show error message and abort if server rejects credentials.
	lang = getBestLanguage()
	#try:
	info = api.login(username, password, lang=lang)
	#except Exception, error:
		#title = mc.GetLocalizedString(6000)
		#message = mc.GetLocalizedString(6020)
		#mc.ShowDialogOk(title, message)
	#	mc.LogDebug('Headweb: Login error: ' + str(error))
	#	mc.ShowDialogOk('Login error', str(error))
	#	return
	fullName = info.firstName + ' ' + info.lastName
	mc.GetActiveWindow().GetLabel(ID_ACCOUNT_FULLNAME).SetLabel(unicode(fullName).encode('utf-8'))
	mc.GetActiveWindow().GetLabel(ID_ACCOUNT_ID).SetLabel(unicode(info.id).encode('utf-8'))
	mc.GetActiveWindow().GetLabel(ID_ACCOUNT_USERNAME).SetLabel(unicode(info.userName).encode('utf-8'))
	mc.GetActiveWindow().GetLabel(ID_ACCOUNT_BALANCE).SetLabel(unicode(info.balance.humanReadable).encode('utf-8'))
	mc.GetActiveWindow().GetLabel(ID_ACCOUNT_CREDITS).SetLabel(unicode(info.credits).encode('utf-8'))
	
	# If all above is ok then show the list.
	rentals = api.rentals(lang=lang)
	items = mc.ListItems()
	
	for rental in rentals:
		item = mc.ListItem(mc.ListItem.MEDIA_VIDEO_CLIP)
		item.SetLabel(unicode(rental.name).encode('utf-8'))
		item.SetTitle(unicode(rental.name).encode('utf-8'))
		item.SetProperty('active', True)
		items.append(item)
	
	activeRentalsList.SetItems(items)

def onLoadInit ():
	"""Performs all initialization on application startup."""
	global api
	
	# Load settings and check if this is the first run. If so then
	# offer the user to specify the account settings.
	localConfig = mc.GetApp().GetLocalConfig()
	firstRun = localConfig.GetValue('com.headweb.firstrun')
	if firstRun == None or firstRun == True:
		localConfig.SetValue('com.headweb.firstrun', False)
		mc.ActivateWindow(14003)
	
	mc.ShowDialogWait()

	# Initialize the genre lists on the "trailers" and "movies" tabs.
	items = mc.ListItems()
	lang = getBestLanguage()
	genreList = api.genre(None, limit=100, lang=lang)
	
	for genre in genreList:
		item = mc.ListItem(mc.ListItem.MEDIA_VIDEO_CLIP)
		item.SetLabel(unicode(genre.name).encode('utf-8'))
		item.SetTitle(unicode(genre.name).encode('utf-8'))
		item.SetProperty('id', unicode(genre.id).encode('utf-8'))
		items.append(item)
	
	mc.GetActiveWindow().GetList(ID_BROWSE_GENRE_LIST).SetItems(items)
	
	# Initialize the keyword lists on the "browse" tab.
	items = mc.ListItems()
	lang = getBestLanguage()
	keywordList = api.keyword(None, limit=100, lang=lang)
	
	for keyword in keywordList:
		item = mc.ListItem(mc.ListItem.MEDIA_VIDEO_CLIP)
		item.SetLabel(unicode(keyword.name).encode('utf-8'))
		item.SetTitle(unicode(keyword.name).encode('utf-8'))
		item.SetProperty('id', unicode(keyword.id).encode('utf-8'))
		items.append(item)
	
	mc.GetActiveWindow().GetList(ID_BROWSE_KEYWORD_LIST).SetItems(items)
	
	# Initialize the groups lists on the "browse" tab.
	items = mc.ListItems()
	lang = getBestLanguage()
	groupList = api.directory(None, limit=100, lang=lang)
	
	for group in groupList:
		item = mc.ListItem(mc.ListItem.MEDIA_VIDEO_CLIP)
		item.SetLabel(unicode(group.name).encode('utf-8'))
		item.SetTitle(unicode(group.name).encode('utf-8'))
		item.SetProperty('id', unicode(group.id).encode('utf-8'))
		items.append(item)
	
	mc.GetActiveWindow().GetList(ID_BROWSE_GROUP_LIST).SetItems(items)

	# Initialize the videoclip lists on the "browse" tab.
	items = mc.ListItems()
	lang = getBestLanguage()
	videoclipList = api.videocliptype(None, limit=100, lang=lang)
	
	for videoclip in videoclipList:
		item = mc.ListItem(mc.ListItem.MEDIA_VIDEO_CLIP)
		item.SetLabel(unicode(videoclip.name).encode('utf-8'))
		item.SetTitle(unicode(videoclip.name).encode('utf-8'))
		item.SetProperty('id', unicode(videoclip.id).encode('utf-8'))
		items.append(item)
	
	mc.GetActiveWindow().GetList(ID_BROWSE_VIDEOCLIP_LIST).SetItems(items)

	mc.HideDialogWait()
	
	mc.LogDebug('Headweb: OnLoadInit(), initialization completed.')

def onGenreClick ():
	#mc.ShowDialogNotification('onGenreClick()')
	performGenreQuery()

def onKeywordClick ():
	#mc.ShowDialogNotification('onKeywordClick()')
	performKeywordQuery()

def onGroupClick ():
	#mc.ShowDialogNotification('onGroupClick()')
	performGroupQuery()

def onVideoClipClick ():
	#mc.ShowDialogNotification('onVideoClipClick()')
	performVideoClipQuery()

def performGenreQuery ():
	global api, globalBrowseQuery
	# Extract the selected/clicked/highlighted genre from list.
	try:
		genreIndex = mc.GetActiveWindow().GetList(ID_BROWSE_GENRE_LIST).GetFocusedItem()
		genreItem = mc.GetActiveWindow().GetList(ID_BROWSE_GENRE_LIST).GetItems()[genreIndex]
		genreId = genreItem.GetProperty('id')
	except:
		mc.LogDebug('Headweb: Unable to retrieve selected genre.')
		mc.ShowDialogNotification('Error: Unable to retrieve selected genre.')
		return
	
	#mc.ShowDialogNotification('Selected genre ID: ' + str(genreId))
	
	mc.ShowDialogWait()
	
	# Query all movies for the selected genre.
	lang = getBestLanguage()
	globalBrowseQuery = api.genre(genreId, lang=lang)

	mc.HideDialogWait()
	
	# Add all queried items to the main result panel.
	items = mc.ListItems()
	for movie in globalBrowseQuery:
		items.append(playlistItemFromItem(movie))
	
	mc.LogDebug("prev: " + str(globalBrowseQuery.hasPrev()) + ", next: " + str(globalBrowseQuery.hasNext()))

	mc.GetActiveWindow().GetList(ID_BROWSE_PANEL).SetItems(items)
	mc.GetActiveWindow().GetControl(ID_BROWSE_PREV).SetEnabled(globalBrowseQuery.hasPrev())
	mc.GetActiveWindow().GetControl(ID_BROWSE_NEXT).SetEnabled(globalBrowseQuery.hasNext())
	mc.GetActiveWindow().GetControl(ID_BROWSE_NEXT).SetEnabled(True)
	mc.GetActiveWindow().GetControl(ID_BROWSE_PREV).SetEnabled(True)
	mc.GetActiveWindow().GetLabel(ID_BROWSE_STATUS).SetLabel(makeStatusString(globalBrowseQuery))
	mc.GetActiveWindow().GetLabel(ID_BROWSE_CURRENT).SetLabel(mc.GetLocalizedString(5550))

def performKeywordQuery ():
	global api, globalBrowseQuery
	# Extract the selected/clicked/highlighted keyword from list.
	try:
		keywordIndex = mc.GetActiveWindow().GetList(ID_BROWSE_KEYWORD_LIST).GetFocusedItem()
		keywordItem = mc.GetActiveWindow().GetList(ID_BROWSE_KEYWORD_LIST).GetItems()[keywordIndex]
		keywordId = keywordItem.GetProperty('id')
	except:
		mc.LogDebug('Headweb: Unable to retrieve selected keyword.')
		mc.ShowDialogNotification('Error: Unable to retrieve selected keyword.')
		return
	
	#mc.ShowDialogNotification('Selected keyword ID: ' + str(keywordId))
	
	mc.ShowDialogWait()
	
	# Query all movies for the selected genre.
	lang = getBestLanguage()
	globalBrowseQuery = api.keyword(keywordId, lang=lang)
	
	mc.HideDialogWait()
	
	# Add all queried items to the main result panel.
	items = mc.ListItems()
	for movie in globalBrowseQuery:
		items.append(playlistItemFromItem(movie))
	
	mc.GetActiveWindow().GetList(ID_BROWSE_PANEL).SetItems(items)
	mc.GetActiveWindow().GetButton(ID_BROWSE_PREV).SetEnabled(globalBrowseQuery.hasPrev())
	mc.GetActiveWindow().GetButton(ID_BROWSE_NEXT).SetEnabled(globalBrowseQuery.hasNext())
	mc.GetActiveWindow().GetLabel(ID_BROWSE_STATUS).SetLabel(makeStatusString(globalBrowseQuery))
	print type(mc.GetLocalizedString(5555))
	mc.GetActiveWindow().GetLabel(ID_BROWSE_CURRENT).SetLabel(mc.GetLocalizedString(5555))
	
def performGroupQuery ():
	global api, globalBrowseQuery
	# Extract the selected/clicked/highlighted keyword from list.
	try:
		groupIndex = mc.GetActiveWindow().GetList(ID_BROWSE_GROUP_LIST).GetFocusedItem()
		groupItem = mc.GetActiveWindow().GetList(ID_BROWSE_GROUP_LIST).GetItems()[groupIndex]
		groupId = groupItem.GetProperty('id')
	except:
		mc.LogDebug('Headweb: Unable to retrieve selected group.')
		mc.ShowDialogNotification('Error: Unable to retrieve selected group.')
		return
	
	#mc.ShowDialogNotification('Selected group ID: ' + str(groupId))
	
	mc.ShowDialogWait()
	
	# Query all movies for the selected genre.
	lang = getBestLanguage()
	globalBrowseQuery = api.directory(groupId, lang=lang)
	
	mc.HideDialogWait()
	
	# Add all queried items to the main result panel.
	items = mc.ListItems()
	for movie in globalBrowseQuery:
		items.append(playlistItemFromItem(movie))
	
	mc.GetActiveWindow().GetList(ID_BROWSE_PANEL).SetItems(items)
	mc.GetActiveWindow().GetButton(ID_BROWSE_PREV).SetEnabled(globalBrowseQuery.hasPrev())
	mc.GetActiveWindow().GetButton(ID_BROWSE_NEXT).SetEnabled(globalBrowseQuery.hasNext())
	mc.GetActiveWindow().GetLabel(ID_BROWSE_STATUS).SetLabel(makeStatusString(globalBrowseQuery))
	mc.GetActiveWindow().GetLabel(ID_BROWSE_CURRENT).SetLabel(mc.GetLocalizedString(5560))

def performVideoClipQuery ():
	global api, globalBrowseQuery
	# Extract the selected/clicked/highlighted videoclip from list.
	try:
		videoclipIndex = int(mc.GetActiveWindow().GetList(ID_BROWSE_VIDEOCLIP_LIST).GetFocusedItem())
		videoclipItem = mc.GetActiveWindow().GetList(ID_BROWSE_VIDEOCLIP_LIST).GetItems()[videoclipIndex]
		videoclipId = videoclipItem.GetProperty('id')
	except:
		mc.LogDebug('Headweb: Unable to retrieve selected videoclip.')
		mc.ShowDialogNotification('Error: Unable to retrieve selected videoclip.')
		return
	
	#mc.ShowDialogNotification('Selected videocliptype ID: ' + str(videoclipId))
	
	mc.ShowDialogWait()
	
	# Query all movies for the selected genre.
	lang = getBestLanguage()
	globalBrowseQuery = api.videocliptype(videoclipId, lang=lang)
	mc.LogDebug("Query items: " + str(globalBrowseQuery.items))
	mc.HideDialogWait()
	
	# Add all queried items to the main result panel.
	items = mc.ListItems()
	for movie in globalBrowseQuery:
		items.append(playlistItemFromItem(movie))
	
	mc.GetActiveWindow().GetList(ID_BROWSE_PANEL).SetItems(items)
	mc.GetActiveWindow().GetButton(ID_BROWSE_PREV).SetEnabled(globalBrowseQuery.hasPrev())
	mc.GetActiveWindow().GetButton(ID_BROWSE_NEXT).SetEnabled(globalBrowseQuery.hasNext())
	mc.GetActiveWindow().GetLabel(ID_BROWSE_STATUS).SetLabel(makeStatusString(globalBrowseQuery))
	mc.GetActiveWindow().GetLabel(ID_BROWSE_CURRENT).SetLabel(mc.GetLocalizedString(5565))

def onBrowseNextClick ():
	"""Called whenever the user requests the next page of titles."""
	global globalBrowseQuery
	if globalBrowseQuery:
		globalBrowseQuery.pageNext()
		mc.GetActiveWindow().GetButton(ID_BROWSE_NEXT).SetEnabled(globalBrowseQuery.hasNext())

def onBrowsePreviousClick ():
	"""Called whenever the user requests the previous page of titles."""
	global globalBrowseQuery
	if globalSearchQuery:
		globalBrowseQuery.pagePrev()
		mc.GetActiveWindow().GetButton(ID_BROWSE_PREV).SetEnabled(globalBrowseQuery.hasPrev())

def onSearchNextClick ():
	"""Called whenever the user requests the next page of titles."""
	global globalSearchQuery
	if globalSearchQuery:
		globalSearchQuery.pageNext()
		mc.GetActiveWindow().GetButton(ID_SEARCH_NEXT).SetEnabled(globalSearchQuery.hasNext())

def onSearchPreviousClick ():
	"""Called whenever the user requests the previous page of titles."""
	global globalSearchQuery
	if globalSearchQuery:
		globalSearchQuery.pagePrev()
		mc.GetActiveWindow().GetButton(ID_SEARCH_PREV).SetEnabled(globalSearchQuery.hasPrev())

def playlistItemFromItem (item, coverQuality = COVER_QUALITY_LISTING):
	"""Creates a complete XBMC playlist item from a given Item.
	The 'coverQuality' parameter determines which cover size to use."""
	
	listItem = mc.ListItem(mc.ListItem.MEDIA_VIDEO_CLIP)
	
	# The 'id' property is a nonstandard one.
	listItem.SetProperty('id', unicode(item.id).encode('utf-8'))
	
	listItem.SetContentType("application/x-shockwave-flash")
	listItem.SetLabel(unicode(item.name).encode('utf-8'))
	listItem.SetTitle(unicode(item.name).encode('utf-8'))
	listItem.SetProviderSource('Headweb On-Demand Video')

	# Find the best cover size to use for this playlist item. If the cover is
	# missing for some reason then default to the Headweb logo.
	if len(item.cover) > 0:
		listItem.SetThumbnail(unicode(item.getCover(coverQuality).url).encode('utf-8'))
	else:
		listItem.SetThumbnail('headweb_bw_logo_sm.png')
		mc.LogDebug(unicode('Headweb: item %d, "%s", no cover available.' % (item.id, item.name)).encode('utf-8'))
	
	# Build the special URL for embedding flash and silverlight content.
	# Some items won't have stream entities (unpublished movies etc.).
	if item.stream != None:
		path = 'flash://headweb.com/src=' + api._makeStreamPath(item.stream.id, 'player')
		listItem.SetPath(unicode(path).encode('utf-8'))
	
		# If runtime is set the propagate to ListItem.
		if item.stream.runtime != None:
			listItem.SetDuration(item.stream.runtime)
		#mc.LogDebug(unicode('Headweb: item %d, "%s", problems with stream entity, dump: %s' % (item.id, item.name, str(item.__dict__))).encode('utf-8'))
	
	return listItem

def makeStatusString (query):
	localizedString = "RESULTS %d TO %d OF %d"
 	return localizedString % (query.offset, query.offset + len(query.list), query.items)
